'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _reactDom = require('react-dom');

var _d3Selection = require('d3-selection');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var representSize = function representSize(size) {
  return size && { size: size, width: size[0], height: size[1] };
};

var _class = function (_Component) {
  _inherits(_class, _Component);

  function _class(props) {
    _classCallCheck(this, _class);

    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, props));

    _this.state = { size: null };
    return _this;
  }

  _createClass(_class, [{
    key: 'setSize',
    value: function setSize() {
      var _props = this.props;
      var width = _props.width;
      var height = _props.height;
      var node = (0, _reactDom.findDOMNode)(this);

      var size = [typeof width === 'function' ? width(node) : typeof width === 'number' ? width : width ? node.parentNode.offsetWidth : null, typeof height === 'function' ? height(node) : typeof height === 'number' ? height : height ? node.parentNode.offsetHeight : null];
      if (this.state.size == null || this.shouldResize(representSize(this.state.size), representSize(size))) {
        this.setState({ size: size });
      }
    }
  }, {
    key: 'shouldResize',
    value: function shouldResize(previous, current) {
      return this.props.width && current.width !== previous.width || this.props.height && current.height !== previous.height;
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.setSize();
      (0, _d3Selection.select)(window).on('resize.' + (this.ns = Math.random()), this.setSize.bind(this));
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      (0, _d3Selection.select)(window).on('resize.' + this.ns, null);
    }
  }, {
    key: 'extraProps',
    value: function extraProps() {
      var props = _extends({}, this.props);
      delete props.children;
      delete props.component;
      delete props.width;
      delete props.height;
      return props;
    }
  }, {
    key: 'render',
    value: function render() {
      var size = this.state.size;
      var _props2 = this.props;
      var children = _props2.children;
      var component = _props2.component;

      return component != null ? (0, _react.createElement)(component, this.extraProps(), size && (typeof children === 'function' ? children(representSize(size)) : _react.Children.map(function (child) {
        return (0, _react.cloneElement)(child, representSize(size));
      }))) : size == null ? (0, _react.createElement)('span') : typeof children === 'function' ? children(representSize(size)) : (0, _react.cloneElement)(_react.Children.only(children), representSize(size));
    }
  }]);

  return _class;
}(_react.Component);

_class.propTypes = {
  width: _react.PropTypes.oneOfType([_react.PropTypes.bool, _react.PropTypes.number, _react.PropTypes.func]),
  height: _react.PropTypes.oneOfType([_react.PropTypes.bool, _react.PropTypes.number, _react.PropTypes.func]),
  component: _react.PropTypes.any
};
_class.defaultProps = {
  width: true,
  height: false
};
exports.default = _class;